unit Dbxloc;
{locate form}
interface

uses
  Forms, StdCtrls, Buttons, Controls, ExtCtrls, Classes,db
  {$IFDEF VER120} {Borland Delphi 4.0 }
  ,dbtables
  {$ENDIF};
{  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,DB;}


type
  Tlocateform = class(TForm)
    CheckBox1: TCheckBox;
    RadioGroup1: TRadioGroup;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    CheckBox2: TCheckBox;
    hLabel: TLabel;
    CheckBox3: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure CreateParams(var Params: TCreateParams);override;
  public
    { Public-Deklarationen }
     onlyVisible: boolean; {use only visible fields in select combo}
     fieldonly: boolean; {use only field of current control in select combo}
     table: TDBDataset;
     StartField:string; {field of the current dbcontrol}
     SearchField:string; {contains the selected field if
                          ok is pressed}
  end;

type
 Tsfield = class
 public
       fieldname:string;
       fieldtype:TFieldType;
       constructor create(s:string;t: TFieldType);
 end;

 var
  locateform: Tlocateform;

implementation
uses sysutils;
{$R *.DFM}

constructor TSField.create(s:string;t: TFieldType);
begin
  fieldname:=s;
  fieldtype:=t;
end;

procedure TLocateform.CreateParams(var Params: TCreateParams);
begin
inherited CreateParams(Params);
  if Application.mainform <> nil then
  with Params do WndParent:= Application.Mainform.handle;
end;

procedure Tlocateform.FormShow(Sender: TObject);
var
   n: integer;
begin
   combobox1.items.clear;
   combobox1.text:='';
   if table <> nil then
   begin
        {startfield is the fieldname of the current
        dbcontrol}
        {if fieldonly then find startfield in fields
        and add it to the select combo}
        if fieldonly and (Length(startfield) > 0) then
        begin
         for n:=1 to table.fieldcount do
         begin
           if not onlyvisible or table.fields[n-1].visible then
           if CompareStr(table.fields[n-1].fieldname,StartField) = 0 then
           combobox1.items.addobject(table.fields[n-1].displayname,
                     TSField.create(table.fields[n-1].fieldname,
                     table.fields[n-1].datatype));
         end;
        end
        else
          {add all fields (or visible only) to the select combo}
          for n:=1 to table.fieldcount do
          begin
            if not onlyvisible or table.fields[n-1].visible then
            combobox1.items.addobject(table.fields[n-1].displayname,
                     TSField.create(table.fields[n-1].fieldname,
                     table.fields[n-1].datatype));
          end;
        combobox1.itemindex:=0;
        {if a fieldname (of the current db-control) is
        given, set item index of combo}
        if length(StartField) > 0 then
        begin
             n:=combobox1.items.indexof(table.fieldbyname(StartField).displayname);
             if n > -1 then combobox1.itemindex:=n;
        end;
        if (table.state <> dsBrowse) and (table.state <> dsInactive) then
         bitbtn1.enabled:=false
        else
         bitbtn1.enabled:=true;
    end
    else
     bitbtn1.enabled:=false;
    edit1.text:='';
    edit1.setfocus;
end;


procedure Tlocateform.BitBtn1Click(Sender: TObject);
begin
  SearchField:=TSField(combobox1.items.objects[combobox1.itemindex]).fieldname;
end;

procedure Tlocateform.FormCreate(Sender: TObject);
begin
     StartField:='';
     SearchField:='';
     Table:=nil;
     onlyVisible:=true;
     fieldonly:=false;
end;

end.
